#include <bits/stdc++.h>
#define ll long long
using namespace std;

ll n;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    ll T;
    cin >> T;
    while(T--){
        cin >> n;
        vector<vector<ll>> a(n, vector<ll>(3));
        for (ll i=0; i<n; i++){
            cin >> a[i][0] >> a[i][1] >> a[i][2];
        }
        vector<ll> sum(2*n+1,0);
        for(ll i=0; i<n; i++){
            sum[a[i][0]]+=a[i][2];
            sum[a[i][1]]+=a[i][2];
        }
        ll sum1 = *max_element(sum.begin(), sum.end());
        ll sum2 = 0;
        for(ll i=0; i<n; i++){
            for (ll j=0; j<n; j++){
                if (j==i) continue;
                if (a[i][1]==a[j][0]){
                    for (int o=0; o<n; o++){
                        if (j==o) continue;
                        if (o==i) continue;
                        if (a[o][1]==a[j][1] && a[i][0]==a[o][0]){
                            sum2=max(sum2, (a[i][2]+a[j][2]+a[o][2]));
                        }
                    }
                } 
            }
        }
        
        cout << max(sum1, sum2) << endl;
    }
}